public class LinkedList<T> {
	
	private class Node {
		private T data;
		private Node next;

		private Node(T data) {
			this.data = data;
			next = null;
		}
	}
	
	private Node head;
	
	public void insertValueAfter(T value, T target) {
		insertValueAfterHelper(head, value, target);
	}
	
	private void insertValueAfterHelper(Node localHead, T value, T target) {
		if (localHead == null) {
			return;
		}
		if (localHead.data.equals(target)) {
			Node n = new Node(value);
			n.next = localHead.next;
			localHead.next = n;
			return;
		}
		insertValueAfterHelper(localHead.next, value, target);
	}


	
	public void insertElementBefore(T targetElement, T toInsert) {
		Node prev = null, curr = head;
		
		while (curr != null) {
			if (curr.data.equals(targetElement)) {
				Node n = new Node(toInsert);
				if (curr == head) {
					n.next = head;
					head = n;
				} else {
					prev.next = n;
					n.next = curr;
				}
				return;
			} else {
				prev = curr;
				curr = curr.next;
			}
		}
	}
}