import java.util.Iterator;

public class Factorial implements Iterable<Long> {

	private int low, high;
	
	public Factorial(int l, int h) {
		low = l;
		high = h;
	}

	private long factorial(int n) {
		long result = 1;
		for (int i = 2; i <= n; i++) {
			result *= i;
		}
		return result;
	}

	public String toString() {
		String v = "";
		for (int i = low; i <= high; i++) {
			v += String.valueOf(factorial(i));
			if (i != high)
				v += ", ";
		}
		return v;
	}
	
	public Iterator<Long> iterator() {
		return new MyIt();
	}

	private class MyIt implements Iterator<Long>{
		int curr;
		
		public MyIt() {
			curr = low;
		}
		public boolean hasNext() {
			return curr <= high;
		}

		public Long next() {
			curr++;
			return factorial(curr - 1);
		}

		public void remove() {
			throw new UnsupportedOperationException();
		}
	}
}