import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;

public class Triple<T extends Comparable <T>> implements Comparable<Triple<T>>, Iterable<T> {

	private T a, b, c;
	private ArrayList<T> sortedCopy = new ArrayList<T>();

	public Triple (T d, T e, T f) {
		a = d;
		b = e; 
		c = f;
		sortedCopy.add(a);
		sortedCopy.add(b);
		sortedCopy.add(c);
		Collections.sort(sortedCopy);
	}

	public String toString() {
		return "[" + a + "," + b + "," + c + "]";
	}
	
	@Override
	public Iterator<T> iterator() {
		return sortedCopy.iterator();
	}

	@Override
	public int compareTo(Triple<T> other) {
		return sortedCopy.get(2).compareTo(other.sortedCopy.get(2));
	}


}
