import javax.swing.table.AbstractTableModel;


class MyTableModel<T> extends  AbstractTableModel {
	private static final long serialVersionUID = 1L;
	private final Queue<T> queue;


	MyTableModel(Queue<T> queue) {
		this.queue = queue;
	}

	public void add(T t) {
		int length = queue.data.length;
		queue.enqueue(t);
		if (length == queue.data.length)
			fireTableDataChanged();
		else {
			fireTableStructureChanged();
		}
	}
	public T remove() {
		T t = queue.dequeue();
		fireTableDataChanged();
		return t;
	}
	public String getColumnName(int col) {
		return Integer.toString(col);
	}
	public int getRowCount() {
		return 3;
	}

	public int getColumnCount() {
		return queue.data.length;
	}

	public Object getValueAt(int row, int col) {
		if (row == 0 && col < queue.data.length)
			return this.queue.data[col];
		if (row == 1 && col == this.queue.headIndex) return "HEAD";
		int tailIndex;
		if (queue.getSize() == 0) {
			tailIndex = 0;
		} else {
			tailIndex = (queue.headIndex + queue.getSize() - 1) % queue.data.length;
		}
		if (row == 2 && col == tailIndex) return "TAIL";
		return "";
	}
}