package dateEx;
import java.util.*;
import java.text.*;

public class DateExample {
	public static void main(String[] args) {
		/* Calendar.getInstance() is a factory class that returns a localized
		 * returns a localized calendar subclass based on your locale.
		 */
		Calendar now = Calendar.getInstance();
		System.out.println("(1)Current date: " + now);
		System.out.println("(2)Time: " + now.getTime());
		
		SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss");
		System.out.println("(3)Current date is " + formatter.format(now.getTime()));
		
		/* Retrieving some values */
		System.out.println("(4)Year: " + now.get(Calendar.YEAR));
		System.out.println("(5)Month: " + now.get(Calendar.MONTH));
		System.out.println("(6)Day of Month: " + now.get(Calendar.DAY_OF_MONTH));
		System.out.println("(7)Day of Week: " + now.get(Calendar.DAY_OF_WEEK));
		System.out.println("(8)Hour: " + now.get(Calendar.HOUR));
		System.out.println("(9)Minute: " + now.get(Calendar.MINUTE));
		System.out.println("(10)Second: " + now.get(Calendar.SECOND));
		System.out.println("(11)AM/PM: " + now.get(Calendar.AM_PM));
		System.out.println("(12)24-Hour: " + now.get(Calendar.HOUR_OF_DAY));
		
		/* Adding three years */
		now.add(Calendar.MINUTE, 3);  /* Try Calendar.HOUR, Calendar.MINUTE and -3*/
		System.out.println("(13)Three years from now " + formatter.format(now.getTime()));
	}
}
